import java.util.*; // Linked List 
import java.awt.*; // Graphics

class Explosion extends Sprite{
static int MAX_LIVE_CYCLES = 10;
int cycles;

	Explosion(Vector2d where){
		location = where.makeCopy(); // could be used without making copy - ship is not moving
		cycles = 0;
		size=1.0/Window.PIXEL_PER_AU; // we could set this so that explosion will explode other things around :)
	}

	public void run(ListIterator sprites){ // update internal state of the object ( x,y, and angle)
		cycles++; // keep track of how many cycles we were alive
		if(cycles == MAX_LIVE_CYCLES){
			sprites.remove(); // remove itself from execution list			
		}
	}

	public void draw(Graphics g){ // let the object draw itself on the buffer
		g.setColor(Color.white);
		Point p = Window.toScreen(location);
		g.drawOval(p.x-cycles/2,p.y-cycles/2,cycles<<2,cycles<<2);
	}

} // class Explosion