import java.util.*; // Random
import java.awt.*; // Graphics

class Missile extends Sprite{
static double MISSILE_SPEED = 0.05;
Vector2d velocity;

	// shipVelocity influences missile velocity
	// shipOrientation should be treated as a unit vector
	Missile(Vector2d shipVelocity, Vector2d shipOrientation,Vector2d loc){
		location = loc.makeCopy();
		velocity = shipOrientation.scale(MISSILE_SPEED).add(shipVelocity);
		size = 1.0/Window.PIXEL_PER_AU;;
	}

	public void run(ListIterator sprites){
		location = location.add(velocity);
		if(collision || location.x < 0.0 || location.x > Window.XOFF||
					location.y < 0 || location.y > Window.YOFF){
			sprites.remove(); // remove itself from the list
		}
	}

	public void draw(Graphics g){ // draw the far away stars
		g.setColor(Color.white);
		Point p = Window.toScreen(location);
		g.fillRect(p.x,p.y,2,2);
	}
}