import java.awt.event.*;
import javax.swing.*; // JFramex
import java.util.*; // linked list

public class SWar extends KeyAdapter{
public static int tics=0; // this is how we keep time
static Random rand = new Random(); // SWar provides all utility functions

Ship ship1; // they have to be class members so that key handler can send them events
Ship ship2;


public static void main(String args[]){
	SWar swar = new SWar();
	swar.run();
}

void sendCommand(int keyCode,boolean upDown){
	switch(keyCode){
		case KeyEvent.VK_A: ship1.left(upDown); break;
		case KeyEvent.VK_S: ship1.right(upDown); break;
		case KeyEvent.VK_D: ship1.go(upDown); break;
		case KeyEvent.VK_F: 
			if(upDown){ ship1.fire(); } break;
		case KeyEvent.VK_K: ship2.left(upDown); break;
		case KeyEvent.VK_L: ship2.right(upDown); break;
		case KeyEvent.VK_SEMICOLON: ship2.go(upDown); break;
		case KeyEvent.VK_QUOTE:
			if(upDown){ ship2.fire(); } break;
	}
}

public void keyPressed(KeyEvent e){	// Invoked when a key has been pressed. 
	sendCommand(e.getKeyCode(),true);
}

public void keyReleased(KeyEvent e){	// Invoked when a key has been released. 
	sendCommand(e.getKeyCode(),false);
}


public void run(){
	boolean gameOver = false;

	Window window = new Window(); // our view port
	window.setSize(Window.SCREEN_WIDTH,Window.SCREEN_HEIGHT);
	window.addKeyListener(this); // this class will handle key presses for the view port

	JFrame frame = new JFrame("Star Wars");
	frame.getContentPane().add(window);
	frame.addKeyListener(this);
	frame.addWindowListener( // make sure window will close when X is pressed
		new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				System.exit(0);
			}
		}
	);
	frame.setLocation(10,10);
	frame.setSize(Window.SCREEN_WIDTH,Window.SCREEN_HEIGHT);
	frame.show();
	// tell user to press g to start the game or add menu
	// we could add code to turn off mouse pointer on mouse over

/**************************************************/

	// create all objects and put them in a list
	Sprite sky = (Sprite) new Sky();
	Sprite star = (Sprite) new Star();
	ship1 = new Ship("ship1");
	ship2 = new Ship("ship2");
	LinkedList objList = new LinkedList();
	objList.add(sky);
	objList.add(star);
	objList.add(ship1);
	objList.add(ship2);

	window.setObjectList(objList); // so that they can be redrawn by window

	while ( ! gameOver){
		ListIterator listi = objList.listIterator(0);
		while(listi.hasNext()){ // let each object in a list update itself
			Sprite current = (Sprite) listi.next();
			current.run(listi);
			if(current != sky){
				ship1.collision(listi,current);
				ship2.collision(listi,current);
				star.collision(listi,current);
			}
		}
		window.repaint(); // now that all object ran and drew themselves, show the universe
		tics = (tics==Integer.MAX_VALUE) ? 0 : tics+1;
		try{
			Thread.sleep(50);
		} catch(Exception e){ System.err.println("Error sleeping..."); }
	}
} // run()
} // SWar