import java.awt.*; // Graphics
import java.util.*; // LinkedList

abstract public class Sprite{
Vector2d location; // coordinates in the Astronomical Units
double size; // used for collision detection
boolean collision = false; // did we just collide?


boolean collision(ListIterator listi, Sprite sprite){ // detect a collision with another sprite
	if(sprite==this){ return false; } // cannot collide with itself
	// each item is a circle ... if centers of the circles are closer than the sum of their
	// radiuses, then a collision occurs
	double dist = location.sub(sprite.location).scalarValue();
//	System.out.print(dist+ " ");
	if( dist < size+sprite.size){
		collision = true;
		sprite.collision = true;
//		System.out.println("Bang...");
		return true;
	}
	return false;
}

	abstract public void run(ListIterator sprites); // update internal state of the object ( x,y, and angle)
	abstract public void draw(Graphics g); // let the object draw itself on the buffer
}