import java.awt.*; // Graphics
import javax.swing.*;
import java.util.*; // LinkedList

class Window extends JPanel{
static int SCREEN_HEIGHT = 500; // some constants in our world - could be moved to other class
static int SCREEN_WIDTH = 500;
static double PIXEL_PER_AU = 250.0f;
static double XOFF = ((float)Window.SCREEN_WIDTH)/Window.PIXEL_PER_AU; // X coordinate off the screen
static double YOFF = ((float)Window.SCREEN_HEIGHT)/Window.PIXEL_PER_AU;

LinkedList sprites;

static public Point toScreen(Vector2d location){
	int x_scr = ((int)(location.x * PIXEL_PER_AU));
	int y_scr = ((int)(location.y * PIXEL_PER_AU));
	return new Point(x_scr,y_scr);
}


public void paintComponent(Graphics g){
	// java will take care of double buffering for us...
	// super.paintComponent(g);
	// for each item in the list, let it paint itself onto buffer
	// iterator cannot handle asynchronous list modifications, array does
	Object arr[] = sprites.toArray(); // sprite list can change any time
	for(int i =0; i < arr.length; i++){
		((Sprite)arr[i]).draw(g);
	}
}


public void setObjectList(LinkedList list){ sprites = list; }


} // Window